//
#include "stdafx.h"

//
#include "PIC16x876Device.h"

//
// PIC16x876  
//
#define PROGRAM_MEMORY_SIZE		(1024*8)
//#define DATA_MEMORY_SIZE		368
#define EEPROM_MEMORY_SIZE		256



// ****************************************************************************
//
//                 ** CPIC16x876Device CLASS /Ҹ **
//
// ****************************************************************************


//
// CPIC16x876Device 
//
//  - 2002.7.10, skr
//
CPIC16x876Device::CPIC16x876Device(void)
	: CPIC16xCore(PROGRAM_MEMORY_SIZE,		// Program Memory ũ
				  EEPROM_MEMORY_SIZE)		// EEPROM Memory ũ
	, m_bErrorOccurred(false)
{
#ifdef _VPM_CONSOLE_TEST
//
	printf("CPIC16x876Device Created!\n");
#endif

	// ھ  ִٸ device  ۵ ʴ´.
	//  ھ  ִ üũϰ ׿ ´ device 
	//  ش.
	if(core_is_error_occurred() == true) {
		m_bErrorOccurred = true;
	} 

	// ھ  ٸ device ʱȭ Ѵ.
	else {
		m_pMemData = core_get_data_mem_ptr();
	}
}

// CPIC16x876Core Ҹ
//
//  - 2002.7.10, skr
//
CPIC16x876Device::~CPIC16x876Device(void)
{
#ifdef _VPM_CONSOLE_TEST
	printf("CPIC16x876Device Destroyed!\n");
#endif
}



// ****************************************************************************
//
//          ** CPIC16xCore Ŭκ  ޾ ϴ Լ **
//
// ****************************************************************************


//
// data memory  д Լ̴.
// core device Ŭ ȣѴ.
//
// - Bank : ޸ ũ
// - RegAddr : data memory address
// - pValue : data pointer
// - return : true
//
//  - 2002.7.13, skr
//
bool
CPIC16x876Device::core_get_frv_ext(u8 Bank,		// bank select
								   u8 RegAddr,	// page   Data Memory Address
								   u8 *pValue)	//  ּҿ ϵ 
{
#ifdef _VPM_CONSOLE_TEST
	printf("core_get_frv_ext(bank : %d, RegAddr : 0x%02x)\n", Bank, RegAddr);
#endif

	// pic16f876 device RegAddr 0x70 ~ 0x7f   bank 0
	// ϰ ִ.
	if(RegAddr > 0x70)
	{
		Bank = 0;
	}

	// bank 2, 3 0x01 0x06 ϴ ɾ 
	// bank 0, 1 Ѵ.
	if( (Bank >= 2) && ( (RegAddr == 0x01) || (RegAddr == 0x06) ) ) {
		Bank -= 2;
	}

	// Bank0̰ų General Purpose Register 쿡   Ǿ Ƿ
	// switch  ʵ Ѵ.
	if( (Bank == 0) || (RegAddr > 0x20) ) 
	{
		*pValue = m_pMemData[( (DATA_MEMORY_BANK_SIZE * Bank) + RegAddr )];

		return (bool)(true);
	}

	//  ܿ   κа  κ ϱ ؼ ġ  Ѵ.
	switch(Bank)
	{
	case 1:
		{
			switch(RegAddr)
			{
				// pic16x876   κ.
			case 0x0f: case 0x10: case 0x15: 
			case 0x16: case 0x17: case 0x1a: 
			case 0x1b: case 0x1c: case 0x1d:
				{
					*pValue = 0;
				}
				break;

			default:
				{
					//  gpr ó  Ѵ.
					*pValue = m_pMemData[( (DATA_MEMORY_BANK_SIZE * Bank) + RegAddr )];
				}
				break;
			} // switch(RegAddr)
		}
		break;

	case 2:
		{
			switch(RegAddr)
			{
				// pic16x876   κ.
			case 0x05: case 0x07: case 0x08: case 0x09:
				{
					*pValue = 0;
				}
				break;

			default:
				{
					//  gpr ó  Ѵ.
					*pValue = m_pMemData[( (DATA_MEMORY_BANK_SIZE * Bank) + RegAddr )];
				}
				break;
			} // switch(RegAddr)
		}
		break;

	case 3:
		{
			switch(RegAddr)
			{
				// pic16x876   κ.
			case 0x05: case 0x07: case 0x08: 
			case 0x09: case 0x0e: case 0x0f:
				{
					*pValue = 0;
				}
				break;

			default:
				{
					//  gpr ó  Ѵ.
					*pValue = m_pMemData[( (DATA_MEMORY_BANK_SIZE * Bank) + RegAddr )];
				}
				break;
			} // switch(RegAddr)
		}
		break;
	}

	return (bool)(true);
}

//
// data memory  ϴ Լ̴.
// core device Ŭ ȣѴ.
//
// - Bank : ޸ ũ
// - RegAddr : data memory address
// - Value : data pointer
// - return : ׻ true
//
//  - 2002.7.13, skr
//
bool
CPIC16x876Device::core_set_frv_ext(u8 Bank,		// bank select
								   u8 RegAddr, 	// page   Data Memory Address
								   u8   Value)	//  ּҿ ϵ 
{
#ifdef _VPM_CONSOLE_TEST
	printf("core_set_frv_ext(bank : %d, RegAddr : 0x%02x)\n", Bank, RegAddr);
#endif

	// pic16f876 device RegAddr 0x70 ~ 0x7f   bank 0
	// ϰ ִ.
	if(RegAddr > 0x70)
	{
		Bank = 0;
	}

	// bank 2, 3 0x01 0x06 ϴ ɾ 
	// bank 0, 1 Ѵ.
	if( (Bank >= 2) && ( (RegAddr == 0x01) || (RegAddr == 0x06) ) ) {
		Bank -= 2;
	}

	//   Ҽ ִ.
	m_pMemData[( (DATA_MEMORY_BANK_SIZE * Bank) + RegAddr )] = Value;

	return (bool)(true);
}



// ****************************************************************************
//
//                      ** MRT  ִ Լ **
//
// ****************************************************************************


//
// Device ̸ ˷ش.
//
// - return : device 
//
//  - 2002.7.16, skr
//
char *
CPIC16x876Device::dev_get_name(void)
const
{
	return (char *)("PIC16x876");
}



// ****************************************************************************
//
//                 ** MRTκ  Է¹޴ Լ **
//
// ****************************************************************************


//
// Device Ŭ ȣ ִ Լ
// MRT ȣ ش.
//
//  - 2002.7.16, skr
//
bool
CPIC16x876Device::dev_clock_in(CLK_SIGNAL clock)
{
	CPIC16xCore::core_clock_in(clock);

	return (bool)(true);
}



// ****************************************************************************
//
//                                ** ӽ Լ **
//
// ****************************************************************************


#ifdef _VPM_CONSOLE_TEST
void
CPIC16x876Device::dev_power_on()
{
	core_init(RST_POR_CON);
}
#endif