//
#ifndef _VPM_DEFINITION
#define _VPM_DEFINITION


//
//   (ver 1.0)
//  - 2002.7.10, skr
//
typedef char			s8;
typedef short			s16;
typedef long			s32;

typedef unsigned char	u8;
typedef unsigned short	u16;
typedef unsigned long	u32;

typedef s8				*ps8;		//  
typedef s16				*ps16;
typedef s32				*ps32;

typedef u8				*pu8;
typedef u16				*pu16;
typedef u32				*pu32;


//  ִ/ּҰ 
#define U8_MAX_VALUE	0xff
#define U16_MAX_VALUE	0xffff
#define U32_MAX_VALUE	0xffffffff

#define U8_MIN_VALUE	0
#define U16_MIN_VALUE	0
#define U32_MIN_VALUE	0

#define S8_MAX_VALUE	0x7f
#define S16_MAX_VALUE	0x7fff
#define S32_MAX_VALUE	0x7fffffff

#define S8_MIN_VALUE	((s8)0x80)
#define S16_MIN_VALUE	((s16)0x8000)
#define S32_MIN_VALUE	((s32)0x80000000)

//
// Ŭ ȣ 
//  - 2002.7.10, skr
//
enum CLK_SIGNAL { CLK_LOW, CLK_HIGH };


//
// DIMS(Details Information of Memory Structure) ü  (ver 1.0)
//  - 2002.7.10, skr
//
typedef struct {
	u16 nPages;
	u32 nWords;
	u8  nBits;
	u32 *pSpecialRange;
	u32 *pUnimplementedRange;
} stDIMS;


//
// DIEMA(Details Information of Each Memory Address) ü  (ver 1.0)
//  - 2002.7.10, skr
//
typedef struct {
	s8   *pInitialValue;
	u8   *pBitsAttributes;
	char *pBitsName;
} stDIEMA;


//
// DISR(Details Information of Special Register) ü  (ver 1.0)
//  - 2002.7.10, skr
//
typedef struct {
	u32  nWords;
	u8   nBits;
//	stDIEMA stDiema;   - 2002.7.10, skr
	s8   *pInitialValue;
	u8   *pBitsAttributes;
	char *pBitsName;
//
} stDISR;


//
#endif // #ifndef _VPM_DEFINITION